﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using SciChart.Charting.Model.DataSeries;
using SciChart.Charting.Model.DataSeries.Heatmap2DArrayDataSeries;

namespace SciChartHeatMap
{
    public class HeatMapViewModel : INotifyPropertyChanged
    {
        private double mColorMax;

        private IDataSeries mDataSeries;

        public IDataSeries Data
        {
            set
            {
                mDataSeries = value;
                OnPropertyChanged();
            }

            get => mDataSeries;
        }

        public double ColorMaximum
        {
            get => mColorMax;

            set
            {
                mColorMax = value;
                OnPropertyChanged();
            }
        }

        public HeatMapViewModel()
        {
            ColorMaximum = 10;

            double [,] fData = new double[10,10];

            Random fRng = new Random();

            for (int fI = 0; fI < 10; ++fI)
            {
                for (int fJ = 0; fJ < 10; ++fJ)
                {
                    fData[fI, fJ] = fRng.NextDouble() * 10;
                }
            }

            Data = new UniformHeatmapDataSeries<int, int, double>(fData, 0, 1, 0, 1);
        }

        #region INotifyPropertyChanged implementation
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string aPropertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(aPropertyName));
        }
        #endregion
    }
}